﻿"use strict";

{
	C3.Plugins.Massive_Cube_jsZip.Instance = class jsZipInstance extends C3.SDKInstanceBase
	{
		constructor(inst, properties)
		{
			super(inst);

			this.zipfile = undefined;
			this.getResults = "teest";

			if (properties)
			{
				
			}

			this.loadFromURL = function(url) {
				JSZipUtils.getBinaryContent(url, this.loadGetBinaryContent, this);
			}

			this.loadGetBinaryContent = function (err, data, _this) {
				    if(err) {
				    	_this.Trigger(C3.Plugins.Massive_Cube_jsZip.Cnds.zipLoadFailed);
				        //throw err;
				    } else {
				    	var prom = JSZip.loadAsync(data).then(_this.loadFlAsync.bind(null,_this));
				    }
			}

			this.loadFlAsync = function (_this,zip) {
						_this.zipfile = zip;
						_this.Trigger(C3.Plugins.Massive_Cube_jsZip.Cnds.zipIsLoaded);
				        //zip.file("Hello.txt").async("string").then(_this.getResultFromFile.bind(null,_this));
			}

			this.loadFileFromZip = function (filename,type) {
				let tpy = "binarystring";
				switch(type) {
					case 0:
						tpy = "base64";
					break;
					case 2:
						tpy = "uint8array";
					break;
					case 3:
						tpy = "blob";
					break;
					case 4:
						tpy = "arraybuffer";
					break;
					case 5:
						tpy = "array";
					break;
					case 6:
						tpy = "nodebuffer";
					break;
				}

				this.zipfile.file(filename).async(tpy).then(this.getResultFromFile.bind(null,this));
			}

			this.getResultFromFile = function (_this,result) {
				_this.getResults = result;
				_this.Trigger(C3.Plugins.Massive_Cube_jsZip.Cnds.zipIsFileLoaded);
			}


		}
		
		Release()
		{
			super.Release();
		}
		
		SaveToJson()
		{
			return {
				// data to be saved for savegames
			};
		}
		
		LoadFromJson(o)
		{
			// load state for savegames
		}
	};
}